#include "clientsock.h"


SERVER cserver;

const char DIRT = '.';
const char WALL = '#';
const char WATER = '~';
const char BASE = '@';
const char BASE_VISITED = '*';
const int PACKAGE_MAX = 10001;
const int ROBOT_MAX = 10001;
const long BUFFER_SIZE = 524288;
const int EXISTS = 1;
const int DELIVERED = -1;
const int UNSURE = 0;
const int UNINITIALIZED = -2;
const int ACCEPTABLE_COST = -5000;
const int COST_DIRT = -1;
const int COST_PROXIMITY = -2;
const int COST_WATER = -50000;
const int COST_BASE = 10;
const int COST_BASE_VISITED = -1;
const int COST_WALL = -50000;
const int NORTH = 0;
const int EAST = 1;
const int SOUTH = 2;
const int WEST = 3;
const char MAX_CAND = 100;
const int BIDRAT = 10;

struct Robot {
	bool initialized;  //false for uninitialized and me
	int x;
	int y;
	int packageCount;
};

struct Package {
	int cx;
	int cy;
	int dx;
	int dy;
	int wt;
	int holder;
	int certainty;
};

struct Point {
	int x;
	int y;
};

void getRobotStatusUpdate();

char* doPickup(int& size, char*);
char* doDrop(int& size, char*);
int evasive(int& buff);
Point decideTarget();
int bestPath(Point, int&);
int coordtoint(Point);
Point inttocoord(int);
Point directionenum(int);
char** buildOutputMap();
void resetBestPath();

inline int greater(int x, int y)
{
if (x>y)
	return x;
else
	return y;
}

//Needs:  "Shortest Path" to destination
	     //Aggression - Push robots just to slow them down
		 //Load optimization
		 //Economic value of pissing off others?
		 //Search for packages.  NOT GIVEN.  Save them in a list.
		 //Location to which packages are going:  random.  
		 //Keep them together!
		 //Limited possibility of moves each time.  Analyze outcome of each one?

//Valued things:
	//Knowledge of packages
	//Delivering packages
		//Cluster packages going to the same area
		//Is package X worth picking up?  
			//Especially if I have to drop another first.
			//Expected future value of each package to optimize turn eff.


	//Life
	//Death of opponents
	//Bids
		//Conseve money based on packages left.
//Predictables
	//Where other players will go
//Could easily be drowned.  IF PUSHED, NO TURN IS DONE.  Therefore, must 
//bid high if lethal push probability is high.

//Packages initially at the home base.

//JOB 1:  Deliver packages.  Deliver packages.  Deliver packages.

//JOB 2:  Stay alive.

//JOB 3:  Aggression, barely worth it.

//Situational analysis:
//	R@M
//  .R.  Being pushed is bad.  In this case, I'd want to go second, but 
//  even then the probability of being pushed off and losing packages
//  is high.  Is it really worth the fuel to fight?  Probably, just move
//  standard in the ideal direction and let everything else go.

// .#.
// RM~
// .#.
// Being pushed here is lethal.  Probably want a heuristic to stay away from
// water.  But must push really hard at R to prevent death!  Fuel is worthless
// when you're dead.

// .#.
// MR~
// .#.
// Probably want to be aggressive here.  How aggressive?  Not quite sure. 
// Consider how long the remaining packages will probably last in moves.
// Can I spare the difference?

// M.@
// ...
// ..D
// Take the route that touches the base!  An early task should be to explore 
// all of these.  Will want a package-ease rating.  Shouldn't be bad to make 
// an equation even to tell me if my ratio would be higher if I just dropped 
// a package and picked up one with a higher ease.

 
Package knownPackages[PACKAGE_MAX];
Robot robots[ROBOT_MAX];
char buffer[BUFFER_SIZE];
char buffer2[BUFFER_SIZE];

char** world;
int** trafficnet;

int worldX;
int worldY;
int myid;
int cRobotCount;
bool alive;
int myFuel;
int myWeight;
int maxWeight;

int* costarray;
int* movearray;


int main(int nums, char *cline[])
{
int a;
int b;
int phase;
int curpackage;
int movedir;
char mvarray[BUFFER_SIZE];
int mvsize;
char** outmap;
Point targetpt;
int cmrating;
char* tmpstr;
char tmpstr2[6];
int frec;
Point ccpt;
Point mypt;

if( cserver.ConnectToServer(cline[1],atoi(cline[2])) < 0 )
{ 
 printf("Error with ConnectToServer(), exiting...."); 
 return false; 
}

alive = true;
//INITIALIZATION PHASE:---------------------------------------

//Initialize Package
for (a=0;a<PACKAGE_MAX;a++)
{
	knownPackages[a].certainty = UNINITIALIZED;
	knownPackages[a].holder = -1;
	knownPackages[a].cx = 0;
	knownPackages[a].cy = 0;
	knownPackages[a].dx = 0;
	knownPackages[a].dy = 0;
	knownPackages[a].wt = 0;
}

//Initialize Robots
for (a=0;a<ROBOT_MAX;a++)
	robots[a].initialized = false;
//Get World Size

//SEND LINE "Player"





//GET WORLDX/Y HERE**************************************

printf("bytes recieved: %d",cserver.recvserv(buffer,BUFFER_SIZE));

printf("\nAfter First Recieve...\n");
printf(buffer);

strcpy(buffer2, strtok(buffer, "\n"));

sscanf(buffer2,"%d %d",&worldX, &worldY);

worldX = worldX + 1;
worldY = worldY + 1;

//For ease of programming, let's keep the coords mapped straight-up.
world = new char*[worldY]; 
trafficnet = new int*[worldY];


//Initialize rows and then read them from the buffer
for (a=1;a<worldY;a++)
{
	world[a] = new char[worldX];
	trafficnet[a] = new int[worldX];

	printf("buffer2 read prepare...\n");

	strcpy(buffer2,strtok(NULL, "\n"));

	printf("buffer2 read OK\n");

	for (b=1;b<worldX;b++)
	{
		//GET NEXT WORLD HERE****************************


		world[a][b] = buffer2[b-1];
		
		//Fill in trafficnet penalties.
		switch (world[a][b])
		{
		case DIRT:
			trafficnet[a][b] = COST_DIRT;
			break;
		case WALL:
			trafficnet[a][b] = COST_WALL;
			break;
		case WATER:
			trafficnet[a][b] = COST_WATER;
			break;
		case BASE:
			trafficnet[a][b] = COST_BASE;
			break;
		}


	}
}


//Take care of water-adjacency penalties now.

for (a=1;a<worldY;a++)
	for (b=1;b<worldX;b++)
	{
	 if (trafficnet[a][b]==WATER)
	 {
	  if (a-1 > 0)
		  trafficnet[a-1][b] -= COST_PROXIMITY;
	  if (a+1 < worldY)
		  trafficnet[a+1][b] -= COST_PROXIMITY;
	  if (b-1 > 0)
		  trafficnet[a][b-1] -= COST_PROXIMITY;
	  if (b+1 < worldX)
		  trafficnet[a][b+1] -= COST_PROXIMITY;
	 }

	}


//GET GAME CONSTANTS HERE*********************************
//Get game constants
strcpy(buffer2, strtok(NULL,"\n"));
sscanf(buffer2,"%d %d %d",&myid, &maxWeight, &myFuel);


//NEED GENERIC ROBOT-STATUS-READ FUNCTION, USE GLOBALS ABOVE

//GET GENERIC ROBOT STATUS UPDATE HERE **********************
strcpy(buffer2, strtok(NULL,"\n"));
strcpy(buffer, buffer2);
getRobotStatusUpdate();

printf("Initialization Complete\n");

while (alive) {
	//GAME PHASE


	resetBestPath();
	printf("Best Path Data Reset\n");

	//Given:  Process packages at current location.  
	//GET PACKAGES HERE, USE strtok

	cserver.recvserv(buffer,BUFFER_SIZE);

	printf("After Package Recieve\n");

	printf(buffer);

	//If there is a package, get the info now.
	if (buffer[0]!='\n')
	{
		tmpstr = strtok(buffer, " ");
		phase = 0;
		while (tmpstr) {
			a = atoi(tmpstr);

			//Do whatever with this int(modular thingy)
			switch (phase)
			{
			case 0:
				curpackage = a;
				knownPackages[curpackage].cx = robots[myid].x;
				knownPackages[curpackage].cy = robots[myid].y;
				break;
			case 1:
				knownPackages[curpackage].dx = a;
				break;
			case 2:
				knownPackages[curpackage].dy = a;
				break;
			case 3:
				knownPackages[curpackage].wt = a;
				break;

			}

			phase = (phase + 1) % 4;
			tmpstr = strtok(NULL, " ");
		}

	}	

	printf("After Package Processing\n");


	//Now that I've gotten the packages, is this a BASE?  If so...

	if (world[robots[myid].y][robots[myid].x] == BASE)
	{
		world[robots[myid].y][robots[myid].x] = BASE_VISITED;
		trafficnet[robots[myid].y][robots[myid].x] = COST_BASE_VISITED;
	}

	printf("After Base Analysis\n");

	//Known:  Past packages
	//Robots location, their packages

	//GAME THEORY ANALYSIS?

	//Print Map
	printf("\n");
	outmap = buildOutputMap();
	for (a=1;a<worldY;a++)
	{
		for (b=1;b<worldX;b++)
		{
			printf("%c", outmap[a][b] );
		}
		printf("\n");
	}
	printf("\n");
	
	//Decide Temp Target

//WORK FROM HERE

	targetpt = decideTarget();

	printf("Target Decided:  ");
	printf("%d %d\n", targetpt.x, targetpt.y);

	//Cargo Management

	printf("Cargo Management: Drop\n");

	doDrop(mvsize, buffer);

	strcpy(mvarray, buffer);

	if (mvsize)
	{
		printf("Cargo Management: Dropping\n");
		buffer[0] = '\0';
		strcat(buffer, "1 Drop");
		strcat(buffer, mvarray);
		myFuel--;

	}
	else
	{
		printf("Cargo Management: Pickup\n");
		doPickup(mvsize, buffer);

		strcpy(mvarray, buffer);

		if (mvsize)
		{
			printf("Cargo Management: Picking up\n");
			buffer[0] = '\0';
			strcat(buffer, "1 Pick");
			strcat(buffer, mvarray);
			myFuel--;
		}
		else
		{
			printf("Deciding on move\n");

			frec = -1;

			movedir = bestPath(targetpt, cmrating);	

			printf("Movedir is %d\n", movedir);

			mypt.x = robots[myid].x;
			mypt.y = robots[myid].y;

			printf("Analyzing opponents\n");

			for (a=0;a<cRobotCount;a++)
			{
				if (robots[a].initialized)
				{
					 ccpt.x = robots[a].x;
					 ccpt.y = robots[a].y;

					 if (abs(ccpt.x - mypt.x) + abs(ccpt.y - mypt.y) == 1)
					 {
						 frec = myFuel / BIDRAT;	
						goto donerat;
					 }

					if (abs(ccpt.x - mypt.x) + abs(ccpt.y - mypt.y) == 2)
					{
						 frec = -1 * myFuel / BIDRAT;
						goto donerat;
					}
	
				}
			}

donerat:

			//Path
		


			//Analyze Defenses
			printf("Finalizing move\n");
			
			sprintf(tmpstr2, "%d", frec);
			//itoa(frec,tmpstr2,10);

			printf("Adding Recommended Fuel\n");

			buffer[0] = '\0';
			strcat(buffer, tmpstr2);
			strcat(buffer, " Move ");

			printf("Adding Move Direction\n");

			switch (movedir)
			{
			case NORTH:
				strcat(buffer, "N");	
				break;
			case SOUTH:
				strcat(buffer, "S");
				break;
			case EAST:
				strcat(buffer, "E");
				break;
			case WEST:
				strcat(buffer, "W");
				break;
			}

		}
	}





	
	//Construct Move
	//Print Move
	strcat(buffer,"\n");
	printf("%s\n", buffer);

	//Send Move

printf("Sending move\n");

cserver.sendserv(buffer);

cserver.recvserv(buffer,BUFFER_SIZE);

printf("Robot Status Update\n");

getRobotStatusUpdate();

//Reset best path data for the next move

//WHAT SIGNALS THAT I'M DEAD?
}
//LOOP

//WE WILL WIN!
return true;

}

void getRobotStatusUpdate()
{
char* tmpstr;
char temp[10];
int c;
int a;
char cmdmode;
int cRobot;

c = 1;

tmpstr = strtok(buffer, " ");
	while (tmpstr) {
		
		switch (tmpstr[0])
		{
		case '#':
			//New robot.  Copy string to new one and convert to integer.
			for (a=1;a<=strlen(tmpstr);a++)
				temp[a-1] = tmpstr[a];
			cRobot = atoi(temp);
			if ((robots[cRobot].initialized==false)&&(cRobot!=myid))
				robots[cRobot].initialized = true;

		break;
		case 'N':
			robots[cRobot].y += 1;
			//GENERIC ROBOT REMOVAL
			if (world[robots[cRobot].y][robots[cRobot].x]==WATER)
			{
				robots[cRobot].initialized = false;
				if (cRobot==myid)
					alive = false;
			}

		break;
		case 'S':
			robots[cRobot].y -= 1;
			//GENERIC ROBOT REMOVAL
			if (world[robots[cRobot].y][robots[cRobot].x]==WATER)
			{
				robots[cRobot].initialized = false;
				if (cRobot==myid)
					alive = false;
			}
		break;
		case 'E':
			robots[cRobot].x += 1;
			//GENERIC ROBOT REMOVAL
			if (world[robots[cRobot].y][robots[cRobot].x]==WATER)
			{
				robots[cRobot].initialized = false;
				if (cRobot==myid)
					alive = false;
			}
		break;
		case 'W':
			robots[cRobot].x -= 1;
			//GENERIC ROBOT REMOVAL
			if (world[robots[cRobot].y][robots[cRobot].x]==WATER)
			{
				robots[cRobot].initialized = false;
				if (cRobot==myid)
					alive = false;
			}
		break;
		case 'P':
			cmdmode = 'P';
			break;
		case 'D':
			cmdmode = 'D';
			break;
		case 'X':
			cmdmode = 'X';
			break;
		case 'Y':
			cmdmode = 'Y';
			break;
		default:
			//It is a number
			a = atoi(tmpstr);

			switch (cmdmode)
			{
			case 'P':
				robots[cRobot].packageCount++;
				knownPackages[a].holder = cRobot;
				break;
			case 'D':
				robots[cRobot].packageCount--;

				knownPackages[a].holder = -1;

				knownPackages[a].cx = robots[cRobot].x;
				knownPackages[a].cy = robots[cRobot].y;

				if ((knownPackages[a].cx==knownPackages[a].dx)&&(knownPackages[a].cy==knownPackages[a].dy))
					knownPackages[a].certainty = DELIVERED;
				else
					knownPackages[a].certainty = UNSURE;
					
				break;
			case 'X':
				robots[cRobot].x = a;
				break;
			case 'Y':
				robots[cRobot].y = a;
				break;

			}
			

		break;
		}

		tmpstr = strtok(NULL, " ");
	}


}

void resetBestPath()
{
	int a;

	costarray = new int[worldX * worldY + 1];
	movearray = new int[worldX * worldY + 1];


	for (a=0;a<worldX * worldY + 1;a++)
	{
		costarray[a] = -10000000;
		movearray[a] = 0;
	}


}


int bestPath(Point target, int& rating)
{

	int arraymax;
	int a;
	int b;
	int startpointI;
	int maxradius; 
	int cradius;
	int cdir;
	int cstep;
	int cphase;
	int chalf;
	int targetI;
	Point startpointP;
	Point cPoint;
	int cPointI;
	int rotdir;
	Point ccPoint;
	int ccPointI;

	printf("Beginning Best Path Algorithm\n");

	arraymax = worldX * worldY + 1;



	//Starting point for search
	startpointP.x = robots[myid].x;
	startpointP.y = robots[myid].y;

	

	//Array mapped starting point
	startpointI = coordtoint(startpointP);

	//Initialize cost of starting point
	costarray[startpointI] = 0;


	//Determine size of search spiral
	maxradius = greater(worldX, worldY) + greater(greater(worldX - startpointP.x,startpointP.x-1),greater(worldY - startpointP.y,startpointP.y-1));



	//Initialize the search point
	cPoint = startpointP;

	//Initialize rotation direction
	rotdir = 1;

	//Determine the target mapped
	targetI = coordtoint(target);

	//Initialize immediately surrounding points.
	for (a=0;a<4;a++)
	{
		ccPoint.x = startpointP.x + directionenum(a).x;
		ccPoint.y = startpointP.y + directionenum(a).y;

	printf("denum is %d %d \n", directionenum(a).x, directionenum(a).y);

		if ((ccPoint.x > 0)&&(ccPoint.y > 0)&&(ccPoint.x < worldX)&&(ccPoint.y < worldY))
		{
		ccPointI = coordtoint(ccPoint);

		movearray[ccPointI] = a;
		costarray[ccPointI] = trafficnet[ccPoint.y][ccPoint.x];
		}

	}
	
	printf("Algorithm Parts Initialized\n");
	printf("TargetI is %d \n", targetI);

	//Go until I find an acceptable path
	//printf("cpoint is %d %d \n", cPoint.x, cPoint.y);

	b = 0;
	cphase = 0;

	while (costarray[targetI]<ACCEPTABLE_COST)
	{
	 //printf("costarray[targetI] is %d \n", costarray[targetI]);
	//Phase 0, increase.  Phase 1, decrease
	if (cphase==0)
	{
		//Initialize variables.
		cradius = 1;
		cstep = 0;
		cdir = NORTH;
		cphase = 1;
		chalf = 0;
		cPoint = startpointP;

		//Go until the spiral is big enough
		while (cradius<=maxradius)
		{
		 
		 //Step one direction in current direction
		 cstep += 1;
		 cPoint.x += directionenum(cdir).x;
		 cPoint.y += directionenum(cdir).y;
		 cPointI = coordtoint(cPoint);

		// Is this a point I can go to?
		 if ((cPoint.x > 0)&&(cPoint.y > 0)&&(cPoint.x < worldX)&&(cPoint.y < worldY))
		 {

			//Have I found a better deal on a surrounding point?
			for (a=0;a<4;a++)
			{

				ccPoint.x = cPoint.x + directionenum(a).x;
				ccPoint.y = cPoint.y + directionenum(a).y;
				ccPointI = coordtoint(ccPoint);

				if ((ccPoint.x > 0)&&(ccPoint.y > 0)&&(ccPoint.x < worldX)&&(ccPoint.y < worldY))
				 {

				if (trafficnet[cPoint.y][cPoint.x] + costarray[ccPointI] > costarray[cPointI])
				{
				 costarray[cPointI] = trafficnet[cPoint.y][cPoint.x] + costarray[ccPointI];
				 movearray[cPointI] = movearray[ccPointI];
				}

				}
			}
		 }

		 //Am I at the end of a radius?  chalf 0, I need to do one more at this radius
		 if (cstep==cradius)
			  if (chalf==0)
			  {
				chalf=1;
				cstep=0;
				cdir+=rotdir+4;
				cdir %= 4;
			  }
			  else
			  {
				cradius+=1;
				chalf=0;
				cstep=0;
				cdir+=rotdir+4;
				cdir %= 4;
			  }

		 }

	 }
	 else
	 {
		//Initialize variables, reverse rotation direction
		cradius = maxradius;
		cstep = 0;
		cdir += 2;
		cdir %= 4;
		cphase = 0;
		chalf = 0;
		rotdir *= -1;

		//printf("Phase 1\n");



		//Keep going until I am at the center of the spiral
		while (cradius>0)
		{
		 //Step one in the prescribed direction
		 cstep += 1;
		 cPoint.x += directionenum(cdir).x;
		 cPoint.y += directionenum(cdir).y;
		 cPointI = coordtoint(cPoint);

		// Have I found a better deal on a surrounding point yet?
		 if ((cPoint.x > 0)&&(cPoint.y > 0)&&(cPoint.x < worldX)&&(cPoint.y < worldY))
		 {

			//if (b++<100)
			//	printf("cpoint is %d %d \n", cPoint.x, cPoint.y);

			for (a=0;a<4;a++)
			{

				ccPoint.x = cPoint.x + directionenum(a).x;
				ccPoint.y = cPoint.y + directionenum(a).y;
				 if ((ccPoint.x > 0)&&(ccPoint.y > 0)&&(ccPoint.x < worldX)&&(ccPoint.y < worldY))
				 {

				ccPointI = coordtoint(ccPoint);

				if (costarray[ccPointI] + trafficnet[cPoint.y][cPoint.x] > costarray[cPointI])
				{
				 costarray[cPointI] = trafficnet[cPoint.y][cPoint.x] + costarray[ccPointI];
				 movearray[cPointI] = movearray[ccPointI];
				}
				 }
			}
		 }

		 //If I'm at the end of a radius, switch direction or radius size as necessary.
		 if (cstep==cradius)
			  if (chalf==0)
			  {
				chalf=1;
				cstep=0;
				cdir+=rotdir+4;
				cdir %= 4;
			  }
			  else
			  {
				cradius-=1;
				chalf=0;
				cstep=0;
				cdir+=rotdir+4;
				cdir %= 4;
			  }

		 }




	 }



	}

	printf("Returning Best Path Algorithm Results: %d %d\n", costarray[targetI], movearray[targetI]);

	rating = costarray[targetI];
	return movearray[targetI];

}

char* doPickup(int& size, char* response)
{
int a;
char tempstr[6];

int dir;
Point cpp;
int mxrating = -10000000;
int trating;
int twt;
bool nopack;
nopack = false;
twt = 0;

while ((twt + myWeight < maxWeight)&&(!(nopack)))
{
nopack = true;
for (a=0;a<PACKAGE_MAX;a++)
{
	if ((knownPackages[a].cx==robots[myid].x)&&(knownPackages[a].cy==robots[myid].y)&&(knownPackages[a].certainty==EXISTS))
	{	
		cpp.x = knownPackages[a].dx;
		cpp.y = knownPackages[a].dy;
		nopack = false;

		//What's my worst package?
		dir = bestPath(cpp, trating);
		if (trating > mxrating)
		{

			mxrating = trating;
			
		}


	}

}

if (!(nopack))
{
for (a=0;a<PACKAGE_MAX;a++)
{
	if ((knownPackages[a].cx==robots[myid].x)&&(knownPackages[a].cy==robots[myid].y)&&(knownPackages[a].certainty==EXISTS))
	{	
		cpp.x = knownPackages[a].dx;
		cpp.y = knownPackages[a].dy;
		nopack = false;

		//What's my worst package?
		dir = bestPath(cpp, trating);
		if (trating = mxrating)
		{
		 strcat(response, " ");
		 sprintf(tempstr, "%d", a);
		 //itoa(a, tempstr, 10);
		 strcat(response, tempstr);
		 knownPackages[a].certainty = UNSURE;
		 twt = twt + knownPackages[a].wt;
		 size++;

			
		}


	}

}
}

}


return response;
}

char* doDrop(int& size, char* response)
{
int a;
char tempstr[6];
int dir;
Point cpp;
int mnrating = 10000000;
int mxrating = -10000000;
int trating;

response[0]='\0';
size = 0;

//Could I drop some randomly just for the sake of hiding them from the opponents?
//NO, if other people have seen them already!

//DEFINITELY drop if we're at a destionation point.

for (a=0;a<PACKAGE_MAX;a++)
{
	if (knownPackages[a].holder==myid)
		if ((knownPackages[a].dx==robots[myid].x)&&(knownPackages[a].dy==robots[myid].y))
		{
		 strcat(response, " ");
		 sprintf(tempstr, "%d", a);
		 //itoa(a, tempstr, 10);
		 strcat(response, tempstr);

		 size++;

		//What's my worst package?
		dir = bestPath(cpp, trating);
		if (trating < mnrating)
			mnrating = trating;
		}



}

for (a=0;a<PACKAGE_MAX;a++)
{
	if ((knownPackages[a].cx==robots[myid].x)&&(knownPackages[a].cy==robots[myid].y)&&(knownPackages[a].certainty==EXISTS))
	{	
		cpp.x = knownPackages[a].dx;
		cpp.y = knownPackages[a].dy;

		//What's the best package
		dir = bestPath(cpp, trating);
		if (trating > mxrating)
			mxrating = trating;

	}

}

if (mxrating > mnrating)
{
//Just drop them all!  Pick up the best later.

for (a=0;a<PACKAGE_MAX;a++)
{
	if (knownPackages[a].holder==myid)
		{
		 strcat(response, " ");
		 sprintf(tempstr, "%d", a);
		 //itoa(a, tempstr, 10);

		 strcat(response, tempstr);

		 size++;
		}
}

}

//POSSIBLY drop if the rating of the score after some pickup is greater than the score for 
//delivery as is.  (SCORE:  Trafficnet + bonuses / moves)  Probably not worth the time often.
//Package Value Formula will be:  Points * 10 / (-n) formula high for small, low for large.


return response;
}

int coordtoint(Point inPoint)
{

return inPoint.x - 1 + (inPoint.y - 1) * (worldX-1);

}

Point inttocoord(int inInt)
{
Point retPoint;

retPoint.x = inInt % (worldX - 1) + 1;
retPoint.y = (inInt - (retPoint.x - 1)) / (worldX - 1) + 1;

return retPoint;
}

Point decideTarget()
{
Point candidates[MAX_CAND];
int a;
int b;
int candcount = 0;
int dir;
int trating;
int minrating = -1000000;
Point cmove;

printf("Deciding Target\n");

if (myWeight==0)
{
printf("Need Packages\n");
//Looking for nearest package
	//check for bases
for (a=1;a<worldX;a++)
	for (b=1;b<worldY;b++)
	  if (world[b][a]==BASE)
	  {
		  candidates[candcount].x = a;
		  candidates[candcount].y = b;	
		  candcount++;
		  if (candcount==MAX_CAND)
			goto candfull;
	  }
	//check for packages

for (a=0;a<PACKAGE_MAX;a++)
	if ((knownPackages[a].certainty==EXISTS)||(knownPackages[a].certainty==UNSURE))
	{
		printf("Considering Candidate: %d %d\n", candidates[candcount].x, candidates[candcount].y);
		candidates[candcount].x = knownPackages[a].cx;
		candidates[candcount].y = knownPackages[a].cy;
		candcount++;
		if (candcount==MAX_CAND)
			goto candfull;
	}



candfull:

printf("Searching candidates\n");

//Search for easiest candidate
for (a=0;a<candcount;a++)
{
	printf("Considering Candidate: %d %d\n", candidates[a].x, candidates[a].y);
	dir = bestPath(candidates[a], trating);

	if (trating > minrating)
	{
	 minrating = trating;
	 cmove = candidates[a];

	}
}

}
else
{
//Looking to drop off nearest package
printf("Need Dropoffs\n");

for (a=0;a<PACKAGE_MAX;a++)
	if (knownPackages[a].holder==myid)
	{
		candidates[0].x = knownPackages[a].cx;
		candidates[0].y = knownPackages[a].cy;

		dir = bestPath(candidates[0], trating);
		if (trating > minrating)
		{
		 minrating = trating;
		 cmove = candidates[0];
	
		}
		
	}





}

printf("Target: %d %d\n", cmove.x, cmove.y);
return cmove;


}

Point directionenum(int dir)
{
Point retpoint;

switch (dir)
{
case NORTH:
	retpoint.x = 0;
	retpoint.y = 1;
	break;
case EAST:
	retpoint.x = -1;
	retpoint.y = 0;
	break;
case SOUTH:
	retpoint.x = 0;
	retpoint.y = -1;
	break;
case WEST:
	retpoint.x = 1;
	retpoint.y = 0;
	break;
}

return retpoint;


}

char** buildOutputMap()
{
int a;
int b;

char** retarray;

retarray = new char*[worldY];

for (a=1;a<worldY;a++)
	retarray[a] = new char[worldX];

for (a=1;a<worldY;a++)
	for (b=1;b<worldX;b++)
	{
	 retarray[a][b] = world[a][b];
	}

for (a=1;a<worldY;a++)
	for (b=1;b<worldX;b++)
	{
	 retarray[a][b] = world[a][b];
	}

for (a=0;a<PACKAGE_MAX;a++)
{
	if (knownPackages[a].certainty==EXISTS)
	{
	 retarray[knownPackages[a].cy][knownPackages[a].cx] = 'P';
	}
	if (knownPackages[a].certainty==UNSURE)
	{
	 retarray[knownPackages[a].cy][knownPackages[a].cx] = '?';
	}
}

for (a=0;a<ROBOT_MAX;a++)
{
	if (robots[a].initialized)
	{
	 retarray[robots[a].y][robots[a].x] = 'O';
	}
}

retarray[robots[myid].y][robots[myid].x] = '*';

return retarray;

}
